;============================================================
; Zelda Graphics Expansion Patch
; -------------------------------
; v2.0
; by gzip
;============================================================

; Includes
; --------
; include the punctuation tile expansion
.include punctuation.asm

;============================================================
; Placeholder Graphics
; --------------------
; These graphics clearly mark the various tiles that have
; been made available to use.
;
; These can be commented out once identified.
;============================================================

; Overworld Primary Blocks
; --------------
; Placeholder Blocks $38-$43 (Tiles $30-$5F)
; Walkable blocks start at $50 which can be modified in HijackCheckWalkable

.PATCH 03:ABDB ; EBEB make sure this matches the pointer under PatternBlockSrcAddrsOW
  .incbin "placeholder_blocks_overworld.chr"

; Dungeon Primary Blocks
; --------------
; Placeholder Blocks $38-$43 (Tiles $30-$5F)
; Walkable blocks start at $50 which can be modified in HijackCheckWalkable

.PATCH 03:AEDB ; EEDB make sure this matches the pointer under PatternBlockSrcAddrsUW
  .incbin "placeholder_blocks_dungeons.chr"

; Individual Tiles
; ----------------
; These are individual tiles that have been freed up for use in block sequences

.PATCH $C9EB ; Tiles 7A and 7B
.data $FF, $5F, $7F, $7F, $7F, $5F, $7F, $00, $80, $00, $00, $00, $00, $00, $00, $00
.data $FF, $FD, $FF, $FF, $FF, $FD, $FF, $01, $00, $00, $00, $00, $00, $00, $00, $01

.PATCH $CA4B ; Tiles 80 and 81
.data $81, $42, $24, $18, $18, $24, $42, $81, $7E, $BD, $DB, $E7, $E7, $DB, $BD, $7E
.data $81, $42, $24, $18, $18, $24, $42, $81, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF

.PATCH $CBDB ; Tile 99
.data $81, $42, $24, $18, $18, $24, $42, $81, $00, $00, $00, $00, $00, $00, $00, $00

.PATCH $CC0B ; Tile 9C, was walkable in Vanilla, changed in overworld_expansion WalkableTileExceptions
.data $7E, $BD, $DB, $E7, $E7, $DB, $BD, $7E, $00, $00, $00, $00, $00, $00, $00, $00

.PATCH $CD0B ; Tiles AC and AD, were walkable in Vanilla, changed in overworld_expansion WalkableTileExceptions
.data $7E, $BD, $DB, $E7, $E7, $DB, $BD, $7E, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
.data $7E, $BD, $DB, $E7, $E7, $DB, $BD, $7E, $81, $42, $24, $18, $18, $24, $42, $81

.PATCH $D08B ; Tile E4
.data $00, $00, $00, $00, $00, $00, $00, $00, $7E, $BD, $DB, $E7, $E7, $DB, $BD, $7E


;============================================================
; Code Changes
; ------------
; PPU tile swaps for overworld/underworld transitions
;============================================================

; Iterations
; ----------
; increase number of transfers to 3

.PATCH 03:805A ; C06A OW was 2
  CMP #$03
.PATCH 03:806D ; C07D UW was 2
  CMP #$03

; Pointers
; --------
; New pointer data to add additional PPU transfers

.PATCH 03:BFC0 ; FFD0
  PatternBlockSrcAddrsUW:
    .data $1B, $81, $BB, $9C ; existing
    .data $DB, $AE           ; new dungeons graphics, must match placeholder graphics pointer
  PatternBlockSrcAddrsOW:
    .data $3B, $89, $5B, $91 ; existing
    .data $DB, $AB           ; new overworld graphics, must match placeholder graphics pointer
  PatternBlockPpuAddrs:
    .data $17, $00, $08, $E0 ; existing
    .data $13, $00           ; new ppu location for both
  PatternBlockPpuAddrsLevelEnemies:
    .data $09, $E0, $0C, $00 ; existing
  PatternBlockSizesOW:
    .data $08, $20, $07, $20 ; existing
    .data $03, $00           ; new overworld data size
  PatternBlockSizesUW:
    .data $08, $20, $01, $00 ; existing
    .data $03, $00           ; new dungeons data size
    .data $02, $20, $04, $00 ; existing

; Pointer References
; ------------------
; Code logic remains unchanged, just updating pointer addresses

.PATCH 03:8085 ; C095
  LDA PatternBlockSrcAddrsUW,X
  STA $00
  INX
  LDA PatternBlockSrcAddrsUW,X
.PATCH 03:8096 ; C0A6
  LDA PatternBlockSrcAddrsOW,X
  STA $00
  LDA PatternBlockSizesOW,X
  STA $02
  INX
  LDA PatternBlockSrcAddrsOW,X
  STA $01
  LDA PatternBlockSizesOW,X
.PATCH 03:80D1 ; C0E1
  LDA PatternBlockSizesUW,X
  STA $02
  INX
  LDA PatternBlockSizesUW,X
.PATCH 03:80E1 ; C0F1
  LDA PatternBlockPpuAddrs,X
  STA $2006
  INX
.PATCH 03:80E8 ; C0F8
  LDA PatternBlockPpuAddrs,X
